Bug 395804 - Regression: "Switch Display" invoked via global shortcut no longer allows keyboard-only operation
Summary: Regression: "Switch Display" invoked via global shortcut no longer allows key...
Status: RESOLVED FIXED
Alias: None
Product: KScreen
Classification: Unclassified
Component: common (show other bugs)
Version: 5.13.1
Platform: Archlinux Packages Linux
: NOR normal
Target Milestone: ---
Assignee: Sebastian Kügler
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2018-06-24 03:26 UTC by andydecleyre
Modified: 2018-10-31 14:25 UTC (History)
3 users (show)

See Also:
Latest Commit:
Version Fixed In: 5.14.0


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description andydecleyre 2018-06-24 03:26:02 UTC
The new pop-up display invoked by the "Switch Display" global keyboard shortcut is very nice, but also brings a regression in that it cannot be operated, or even exited, using the keyboard alone. It does not take keyboard focus, so ESC or cursor keys or Enter or any other keys affect an active window below the pop-up, which I find unexpected and inconvenient.

In my case, I'm often using the global shortcut after hooking up a laptop to one or more external displays and then moving across a room to operate by wireless keyboard, which is now impossible.

I suggest keyboard operability to be restored by having the pop-up take keyboard focus, having ESC trigger the "Leave unchanged" action, cursor keys change which action is selected, and Enter trigger the selected action. I do not know which action ought to be selected initially.
Comment 1 Sebastian Kügler 2018-06-27 07:25:05 UTC
Thanks for the bug report! This seems like an oversight, indeed.
Comment 2 Nate Graham 2018-07-24 12:51:47 UTC
Fixed by https://phabricator.kde.org/D14165
Comment 3 andydecleyre 2018-10-29 00:45:09 UTC
I'd like to note here that as the feature previously worked, in the case where unplugging an external monitor resulted in no active display at all, one could get a working display by simply hitting the shortcut repeatedly.

Now, if that happens, one needs to hit the shortcut, then (know to) hit the right arrow, then enter. Unless of course the cursor happened to be over where one of the choices appeared, in which case the number of times to hit the right arrow in this sequence changes (to an unknown value to the user). So potentially: shortcut, right, enter, shortcut, right, right, enter, shortcut, right, right, right, enter.
Comment 4 Nate Graham 2018-10-29 20:29:50 UTC
So maybe we should make the Switch Display key/keyboard shortcut toggle between options on the OSD if it's already open. Can you file a new bug to track that? Thanks!
Comment 5 andydecleyre 2018-10-30 12:51:26 UTC
(In reply to Nate Graham from comment #4)
> So maybe we should make the Switch Display key/keyboard shortcut toggle
> between options on the OSD if it's already open. Can you file a new bug to
> track that? Thanks!

I'm not sure the behavior you suggest is clear to me. Is the idea that the new worst-case action is:

Trigger, enter; trigger, trigger, enter; trigger, trigger, trigger, enter; etc?
Comment 6 Nate Graham 2018-10-31 13:58:25 UTC
Do you have a better suggestion?
Comment 7 andydecleyre 2018-10-31 14:25:09 UTC
I just wanted to ensure I understood the suggestion. 

Hopefully tonight I'll open three related issues.